#include "cubeMap.h"
//#include "RTConfig.h"
#include <qmessagebox.h>

#include "scene.h"
#define GL_TEXTURE_RECTANGLE_EXT 0x84F5


// Pour ne pas avoir a mettre qglviewer:: devant les classes
// definies dans le namespace qglviewer.
using namespace qglviewer;

CubeMap::CubeMap() {
	  setTextureScale(1.0);
}

void CubeMap::draw() const
{
  float size = 500;

  glPushAttrib(GL_ALL_ATTRIB_BITS);
  glDisable(GL_LIGHTING);
  
  glColor4f(0.8,0.8,0.8,1.0);

  glEnable(GL_DEPTH_TEST);
  glDisable(GL_STENCIL_TEST);

  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);

//  glBindTexture(GL_TEXTURE_RECTANGLE_EXT, (mutable GLuint)"alpright.jpg");
  glEnable(GL_TEXTURE_RECTANGLE_EXT);

glColor4f(1,1,1,0.7);


  // Base
  glBegin(GL_QUADS);

  // back
  glVertex3f(-size, size, size);
  glVertex3f(size, size, size);
  glVertex3f(size, size, -size);
  glVertex3f(-size, size, -size);

  // front
  glVertex3f(-size, -size, size);
  glVertex3f(size, -size, size);
  glVertex3f(size, -size, -size);
  glVertex3f(-size, -size, -size);

  // right
  glVertex3f(size, -size, size);
  glVertex3f(size, size, size);
  glVertex3f(size, size, -size);
  glVertex3f(size, -size, size);

  // left
  glVertex3f(-size, -size, size);
  glVertex3f(-size, size, size);
  glVertex3f(-size, size, -size);
  glVertex3f(-size, -size, size);

  // up
  glVertex3f(-size, -size, size);
  glVertex3f(-size, size, size);
  glVertex3f(size, size, size);
  glVertex3f(size, -size, size);

  // down
  glVertex3f(-size, -size, -size);
  glVertex3f(-size, size, -size);
  glVertex3f(size, size, -size);
  glVertex3f(size, -size, -size);

  glEnd();
 
/*

  glBegin(GL_QUADS);
	  glTexCoord2f(0,yResolution());
	  glVertex3f( -halfWidth, -halfHeight, -dist);

	  glTexCoord2f(xResolution(),yResolution());
	  glVertex3f( halfWidth, -halfHeight, -dist);

	  glTexCoord2f(xResolution(), 0);
	  glVertex3f( halfWidth, halfHeight, -dist);

	  glTexCoord2f(0, 0);
	  glVertex3f( -halfWidth, halfHeight, -dist);
  glEnd();
*/
  glDisable(GL_BLEND);

  glEnable(GL_DEPTH_TEST);

 
  glEnd();
  glPopAttrib();
}

void CubeMap::initFromDOMElement(const QDomElement& e)
{
  if (e.tagName() != "CubeMap")
    {
      QMessageBox::critical(NULL, "CubeMap init error", "CubeMap::initFromDOMElement, bad DOM tagName.\nExpecting 'CubeMap', got "+e.tagName());
      return;
    }

  QDomNode n = e.firstChild();

  while (!n.isNull()) {

      QDomElement e = n.toElement();
      if (!e.isNull()) {

		if(e.tagName() == "Scale")
			setTextureScale(e.attribute("scale", "1.0").toFloat());

		 if (e.tagName() == "UpMap")
//			  loadTextureFromFile(e.attribute("file"), cubeMapUp_);
			  loadTextureFromFileUp(e.attribute("file"));
		 else if (e.tagName() == "DownMap")
			  //loadTextureFromFile(e.attribute("file"), cubeMapDown_);
			  loadTextureFromFileDown(e.attribute("file"));
		 else if (e.tagName() == "LeftMap")
			  //loadTextureFromFile(e.attribute("file"), cubeMapLeft_);
			  loadTextureFromFileLeft(e.attribute("file"));
		 else if (e.tagName() == "RightMap")
			  //loadTextureFromFile(e.attribute("file"), cubeMapRight_);
			  loadTextureFromFileRight(e.attribute("file"));
		 else if (e.tagName() == "BackMap")
			  //loadTextureFromFile(e.attribute("file"), cubeMapBack_);
			  loadTextureFromFileBack(e.attribute("file"));
		 else if (e.tagName() == "ForwardMap")
			  //loadTextureFromFile(e.attribute("file"), cubeMapForward_);
			  loadTextureFromFileForward(e.attribute("file"));

		 else
			  QMessageBox::warning(NULL, "CubeMap child error", "Unsupported CubeMap  child : "+e.tagName()); 
	  }
      else
		  QMessageBox::warning(NULL, "CubeMap  XML error", "Error while parsing CubeMap  XML document");

      n = n.nextSibling();
    }
}

void CubeMap::loadTextureFromFile(const QString& fileName, QImage cubeSide)
{
  if (fileName.isNull())
    QMessageBox::warning(NULL, "CubeMap  texture error", "CubeMap error : no texture file name provided");
  else
    if (!cubeSide.load(fileName))
      QMessageBox::warning(NULL, "CubeMap  texture error", "Unable to load CubeMap texture from "+fileName);
}


void CubeMap::loadTextureFromFileUp(const QString& fileName)
{
  if (fileName.isNull())
    QMessageBox::warning(NULL, "CubeMap  texture error", "CubeMap error : no texture file name provided");
  else
    if (!cubeMapUp_.load(fileName))
      QMessageBox::warning(NULL, "CubeMap  texture error", "Unable to load CubeMap texture from "+fileName);
}


void CubeMap::loadTextureFromFileDown(const QString& fileName)
{
  if (fileName.isNull())
    QMessageBox::warning(NULL, "CubeMap  texture error", "CubeMap error : no texture file name provided");
  else
    if (!cubeMapDown_.load(fileName))
      QMessageBox::warning(NULL, "CubeMap  texture error", "Unable to load CubeMap texture from "+fileName);
}


void CubeMap::loadTextureFromFileLeft(const QString& fileName)
{
  if (fileName.isNull())
    QMessageBox::warning(NULL, "CubeMap  texture error", "CubeMap error : no texture file name provided");
  else
    if (!cubeMapLeft_.load(fileName))
      QMessageBox::warning(NULL, "CubeMap  texture error", "Unable to load CubeMap texture from "+fileName);
}


void CubeMap::loadTextureFromFileRight(const QString& fileName)
{
  if (fileName.isNull())
    QMessageBox::warning(NULL, "CubeMap  texture error", "CubeMap error : no texture file name provided");
  else
    if (!cubeMapRight_.load(fileName))
      QMessageBox::warning(NULL, "CubeMap  texture error", "Unable to load CubeMap texture from "+fileName);
}

void CubeMap::loadTextureFromFileBack(const QString& fileName)
{
  if (fileName.isNull())
    QMessageBox::warning(NULL, "CubeMap  texture error", "CubeMap error : no texture file name provided");
  else
    if (!cubeMapBack_.load(fileName))
      QMessageBox::warning(NULL, "CubeMap  texture error", "Unable to load CubeMap texture from "+fileName);
}

void CubeMap::loadTextureFromFileForward(const QString& fileName)
{
  if (fileName.isNull())
    QMessageBox::warning(NULL, "CubeMap  texture error", "CubeMap error : no texture file name provided");
  else
    if (!cubeMapForward_.load(fileName))
      QMessageBox::warning(NULL, "CubeMap  texture error", "Unable to load CubeMap texture from "+fileName);
}

Color CubeMap::getColor(float u, float v, int side) const
{
	if (texture(side).isNull()) {
	return /*scene()->backgroundColor()*/Color(0,0,0);
	}

  

  // Take texture scaling into account
  u /= textureScaleU();
  v /= textureScaleV();

  // Compute pixel coordinates
  const int i = int(fabs(u - floor(u)) * texture(side).width());
  const int j = int(fabs(v - floor(v)) * texture(side).height());

  return Color(texture(side).pixel(i,j));
}


Color CubeMap::readCubeMap(const Ray &ray) const {

	float u; // = (atan2(ray.direction().y,ray.direction().x)+M_PI)/(2.0f*M_PI);
	float v; // = (acosf(ray.direction().z/this->radius()))/(M_PI);
	int side;

	if ((fabsf(ray.direction().x) >= fabsf(ray.direction().y)) && (fabsf(ray.direction().x) >= fabsf(ray.direction().z)))
    {
		if (ray.direction().x >= 0.0f) {
			u = 1.0f - (-ray.direction().y / ray.direction().x+ 1.0f) * 0.5f;
			v = (ray.direction().z / ray.direction().x+ 1.0f) * 0.5f;
			side = 3; // right side
		}
		else if (ray.direction().x < 0.0f) {
			u = 1.0f - (-ray.direction().y / ray.direction().x+ 1.0f) * 0.5f;
            v = 1.0f - ( ray.direction().z / ray.direction().x + 1.0f) * 0.5f;
			side = 2; // left side
		}
    }
	else if ((fabsf(ray.direction().y) >= fabsf(ray.direction().x)) && (fabsf(ray.direction().y) >= fabsf(ray.direction().z)))
    {
		if (ray.direction().y >= 0.0f) {
			u = ray.direction().x / ((-ray.direction().y) + 1.0f) * 0.5f;
            v = 1.0f - (ray.direction().z /(-ray.direction().y)+1) * 0.5f; 
			side = 4; // back side
		}
		else if (ray.direction().y < 0.0f) {
			u = (ray.direction().x / (-ray.direction().y) + 1.0f) * 0.5f;
            v = (ray.direction().z/(-ray.direction().y) + 1.0f) * 0.5f;
			side = 5; // forward side
		}
    }
	else if ((fabsf(ray.direction().z) >= fabsf(ray.direction().x)) && (fabsf(ray.direction().z) >= fabsf(ray.direction().y)))
    {
		if (ray.direction().z >= 0.0f) {
			u = (ray.direction().x / ray.direction().z + 1.0f) * 0.5f;
            v = 1.0f - ((-ray.direction().y)/ ray.direction().z + 1.0f) * 0.5f;
			side = 0; // up side
		}
		else if (ray.direction().z < 0.0f) {
			u = 1.0f - (ray.direction().x / ray.direction().z + 1.0f) * 0.5f;
            v = ((-ray.direction().y)/ray.direction().z + 1.0f) * 0.5f;
			side = 1; // down side
		}
    }

	return getColor(u, v, side);

}



Color CubeMap::readCubeMap2(const Ray &ray) const {

	float u; // = (atan2(ray.direction().y,ray.direction().x)+M_PI)/(2.0f*M_PI);
	float v; // = (acosf(ray.direction().z/this->radius()))/(M_PI);
	int side;

	if ((fabsf(ray.direction().x) >= fabsf(ray.direction().y)) && (fabsf(ray.direction().x) >= fabsf(ray.direction().z)))
    {
		// right side
		if (ray.direction().x >= 0.0f) {
			side = 3;
			
			// compute u
			float alpha = acosf(ray.direction().x);
			if (ray.direction().y > 0)
				u = 2 * texture(side).width() * (M_PI / 4.0f - alpha) / M_PI;
			else
				u = 2 * texture(side).width() * (M_PI / 4.0f + alpha) / M_PI;

			// compute v
			float beta = acosf(ray.direction().y);
			if (ray.direction().z > 0)
				v = 2 * texture(side).height() * (M_PI / 4.0f - beta) / M_PI;
			else
				v = 2 * texture(side).height() * (M_PI / 4.0f + beta) / M_PI;		

			return Color(texture(side).pixel(fabs(u),fabs(v)));
 		}

		// left side
		else if (ray.direction().x < 0.0f) {
			side = 2;
			
			// compute u
			float alpha = acosf(ray.direction().x);
			if (ray.direction().y > 0)
				u = 2 * texture(side).width() * (M_PI / 4.0f + alpha) / M_PI;
			else
				u = 2 * texture(side).width() * (M_PI / 4.0f - alpha) / M_PI;

			// compute v
			float beta = acosf(ray.direction().y);
			if (ray.direction().z > 0)
				v = 2 * texture(side).height() * (M_PI / 4.0f + beta) / M_PI;
			else
				v = 2 * texture(side).height() * (M_PI / 4.0f - beta) / M_PI;		

			return Color(texture(side).pixel(fabs(u),fabs(v)));
		}
    }
	else return Color(0,0,0);
/*
	else if ((fabsf(ray.direction().y) >= fabsf(ray.direction().x)) && (fabsf(ray.direction().y) >= fabsf(ray.direction().z)))
    {
		if (ray.direction().y >= 0.0f) {
			u = ray.direction().x / ((-ray.direction().y) + 1.0f) * 0.5f;
            v = 1.0f - (ray.direction().z /(-ray.direction().y)+1) * 0.5f; 
			side = 4; // back side
		}
		else if (ray.direction().y < 0.0f) {
			u = (ray.direction().x / (-ray.direction().y) + 1.0f) * 0.5f;
            v = (ray.direction().z/(-ray.direction().y) + 1.0f) * 0.5f;
			side = 5; // forward side
		}
    }
	else if ((fabsf(ray.direction().z) >= fabsf(ray.direction().x)) && (fabsf(ray.direction().z) >= fabsf(ray.direction().y)))
    {
		if (ray.direction().z >= 0.0f) {
			u = (ray.direction().x / ray.direction().z + 1.0f) * 0.5f;
            v = 1.0f - ((-ray.direction().y)/ ray.direction().z + 1.0f) * 0.5f;
			side = 0; // up side
		}
		else if (ray.direction().z < 0.0f) {
			u = 1.0f - (ray.direction().x / ray.direction().z + 1.0f) * 0.5f;
            v = ((-ray.direction().y)/ray.direction().z + 1.0f) * 0.5f;
			side = 1; // down side
		}
    }
*/
	return getColor(u, v, side);

}



/*
Color CubeMap::readCubeMap(const Ray &ray, const float radius) const {

	float u = (atan2(ray.direction().y,ray.direction().x)+M_PI)/(2.0f*M_PI);
	float v = (acosf(ray.direction().z/radius))/(M_PI);
	int side;

	if ((fabsf(ray.direction().x) >= fabsf(ray.direction().y)) && (fabsf(ray.direction().x) >= fabsf(ray.direction().z)))
    {
		if (ray.direction().x >= 0.0f) {
	//		u = 1.0f - (-ray.direction().y / ray.direction().x+ 1.0f) * 0.5f;
	//		v = (ray.direction().z / ray.direction().x+ 1.0f) * 0.5f;
			side = 3; // right side
		}
		else if (ray.direction().x < 0.0f) {
	//		u = 1.0f - (-ray.direction().y / ray.direction().x+ 1.0f) * 0.5f;
     //       v = 1.0f - ( ray.direction().z / ray.direction().x + 1.0f) * 0.5f;
			side = 2; // left side
		}
    }
	else if ((fabsf(ray.direction().y) >= fabsf(ray.direction().x)) && (fabsf(ray.direction().y) >= fabsf(ray.direction().z)))
    {
		if (ray.direction().y >= 0.0f) {
	//		u = ray.direction().x / ((-ray.direction().y) + 1.0f) * 0.5f;
      //      v = 1.0f - (ray.direction().z /(-ray.direction().y)+1) * 0.5f; 
			side = 4; // back side
		}
		else if (ray.direction().y < 0.0f) {
		//	u = (ray.direction().x / (-ray.direction().y) + 1.0f) * 0.5f;
          //  v = (ray.direction().z/(-ray.direction().y) + 1.0f) * 0.5f;
			side = 5; // forward side
		}
    }
	else if ((fabsf(ray.direction().z) >= fabsf(ray.direction().x)) && (fabsf(ray.direction().z) >= fabsf(ray.direction().y)))
    {
		if (ray.direction().z >= 0.0f) {
		//	u = (ray.direction().x / ray.direction().z + 1.0f) * 0.5f;
        //    v = 1.0f - ((-ray.direction().y)/ ray.direction().z + 1.0f) * 0.5f;
			side = 0; // up side
		}
		else if (ray.direction().z < 0.0f) {
		//	u = 1.0f - (ray.direction().x / ray.direction().z + 1.0f) * 0.5f;
         //   v = ((-ray.direction().y)/ray.direction().z + 1.0f) * 0.5f;
			side = 1; // down side
		}
    }

	return getColor(u, v, side);

}
*/