#ifndef RAY_H
#define RAY_H

#include <QGLViewer/frame.h>

class Ray
{
public :
  Ray();
  Ray(const qglviewer::Vec start, const qglviewer::Vec dir);
  
  qglviewer::Vec start() const { return start_; }
  qglviewer::Vec direction() const { return direction_; }
  
  void setStart(const qglviewer::Vec& start) { start_ = start; }
  void setDirection(const qglviewer::Vec& direction);

  void draw() const;

  
  //For optimized ray-box intersection//
  qglviewer::Vec inv_direction;
  int sign[3];
private:
  qglviewer::Vec start_, direction_;

  
};

#endif // RAY_H
