#include "spacePartition.h"
#include "RTConfig.h"

using namespace qglviewer;

namespace SpacePartition{


void drawCube(qglviewer::Vec &p1, qglviewer::Vec &p2) {

glBegin(GL_QUADS);
		// Front Face
		glTexCoord2f(0.0f, 0.0f); glVertex3f(p1.x, p1.y,  p2.z);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(1.0f, 0.0f); glVertex3f( p2.x, p1.y,  p2.z);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f( p2.x,  p2.y,  p2.z);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f(p1.x,  p2.y,  p2.z);	// Top Left Of The Texture and Quad
		// Back Face
		glTexCoord2f(1.0f, 0.0f); glVertex3f(p1.x, p1.y, p1.z);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f(p1.x,  p2.y, p1.z);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f( p2.x,  p2.y, p1.z);	// Top Left Of The Texture and Quad
		glTexCoord2f(0.0f, 0.0f); glVertex3f( p2.x, p1.y, p1.z);	// Bottom Left Of The Texture and Quad
		// Top Face
		glTexCoord2f(0.0f, 1.0f); glVertex3f(p1.x,  p2.y, p1.z);	// Top Left Of The Texture and Quad
		glTexCoord2f(0.0f, 0.0f); glVertex3f(p1.x,  p2.y,  p2.z);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(1.0f, 0.0f); glVertex3f( p2.x,  p2.y,  p2.z);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f( p2.x,  p2.y, p1.z);	// Top Right Of The Texture and Quad
		// Bottom Face
		glTexCoord2f(1.0f, 1.0f); glVertex3f(p1.x, p1.y, p1.z);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f( p2.x, p1.y, p1.z);	// Top Left Of The Texture and Quad
		glTexCoord2f(0.0f, 0.0f); glVertex3f( p2.x, p1.y,  p2.z);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(1.0f, 0.0f); glVertex3f(p1.x, p1.y,  p2.z);	// Bottom Right Of The Texture and Quad
		// Right face
		glTexCoord2f(1.0f, 0.0f); glVertex3f( p2.x, p1.y, p1.z);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f( p2.x,  p2.y, p1.z);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f( p2.x,  p2.y,  p2.z);	// Top Left Of The Texture and Quad
		glTexCoord2f(0.0f, 0.0f); glVertex3f( p2.x, p1.y,  p2.z);	// Bottom Left Of The Texture and Quad
		// Left Face
		glTexCoord2f(0.0f, 0.0f); glVertex3f(p1.x, p1.y, p1.z);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(1.0f, 0.0f); glVertex3f(p1.x, p1.y,  p2.z);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f(p1.x,  p2.y,  p2.z);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f(p1.x,  p2.y, p1.z);	// Top Left Of The Texture and Quad
	glEnd();

}


bool BBox::boxIntersect(const Ray& r, Hit& hit) const{
		//bounding box intersection algorithm from "An Efficient and Robust Ray-Box Intersection Algorithm"

	  float t0= RTConfig::getInstance()->getRayTMin();//hit.time()<1.0E5 ? hit.time() : RTConfig::getInstance()->getRayTMin();//RTConfig::getInstance()->getRayTMin();
	  float t1=999.0f;//hit.time();

	  float tmin, tmax, tymin, tymax, tzmin, tzmax;

	  tmin = (bbox[r.sign[0]].x - r.start().x) * r.inv_direction.x;
	  tmax = (bbox[1-r.sign[0]].x - r.start().x) * r.inv_direction.x;
	  tymin = (bbox[r.sign[1]].y - r.start().y) * r.inv_direction.y;
	  tymax = (bbox[1-r.sign[1]].y - r.start().y) * r.inv_direction.y;
	  if ( (tmin > tymax) || (tymin > tmax) ) 
		return false;
	  if (tymin > tmin)
		tmin = tymin;
	  if (tymax < tmax)
		tmax = tymax;
	  tzmin = (bbox[r.sign[2]].z - r.start().z) * r.inv_direction.z;
	  tzmax = (bbox[1-r.sign[2]].z - r.start().z) * r.inv_direction.z;
	  if ( (tmin > tzmax) || (tzmin > tmax) ) 
		return false;
	  if (tzmin > tmin)
		tmin = tzmin;
	  if (tzmax < tmax)
		tmax = tzmax;

	  return ( (tmin < t1) && (tmax > t0) );
}


//class Triangle//
void Triangle::compBBox(){
	bbox[0]=qglviewer::Vec(999.0f,999.0f,999.0f);
	bbox[1]=qglviewer::Vec(-999.0f,-999.0f,-999.0f);

	for(int i=0; i<3; i++){

		for(int j=0; j<3; j++){
			if(v[i].v_[j]<this->bbox[0].v_[j])
				this->bbox[0].v_[j]=v[i].v_[j];

			if(v[i].v_[j]>this->bbox[1].v_[j])
				this->bbox[1].v_[j]=v[i].v_[j];
		}

	}
}

///////////////////

bool Triangle::triangleIntersect(const Ray& ray, Hit& hit)const
{
  bool res;

  float t, u, v;
  
  Vec dir=ray.direction();
  Vec orig=ray.start();

  float EPSILON=0.00001;

  Vec vert0=this->v[0];
  Vec vert1=this->v[1];
  Vec vert2=this->v[2];


  ////Ray triangle intersection from "Fast Minimum Storage RayTriangle Intersection" [MollerTrumbore97]

   //double edge1[3], edge2[3], tvec[3], pvec[3], qvec[3];
   Vec edge1, edge2, pvec, tvec, qvec;
   float det,inv_det;

   /* find vectors for two edges sharing vert0 */
   edge1= vert1-vert0;
   edge2= vert2-vert0;

   /* begin calculating determinant - also used to calculate U parameter */
   pvec= cross(dir, edge2);

   /* if determinant is near zero, ray lies in plane of triangle */
   det = edge1 * pvec; //dot

   if (det > -EPSILON && det < EPSILON)
     return false;

   inv_det = 1.0f / det;

   /* calculate distance from vert0 to ray origin */
   tvec = orig - vert0;

   /* calculate U parameter and test bounds */
   u = (tvec * pvec) * inv_det; //dot
   if (u < 0.0 || u > 1.0)
     return false;

   /* prepare to test V parameter */
   qvec= cross(tvec, edge1);

   /* calculate V parameter and test bounds */
   v = (dir * qvec) * inv_det; //dot
   if (v < 0.0 || u + v > 1.0)
     return false;

   /* calculate t, ray intersects triangle */
   t = (edge2 * qvec) * inv_det; //dot


  float tmin=RTConfig::getInstance()->getRayTMin();// 0.0001;

  if(hit.time()>t && t>tmin){
	  hit.setTime(t);
	  hit.setIntersection( ray.direction()*t+ray.start() );
	  //hit.setMaterial(this->material());
	 
	  // "Partie XI: Textures"
	  //Vec texuv= v*(u*this->t[0])+((1.0f-u)*this->t[2]) + (1.0f-v)*(u*this->t[0])+((1.0f-u)*this->t[1]);
	  Vec texuv= ((1.0f-u-v)*this->t[0]+ (u)*this->t[1]+(v)*this->t[2]);
	  hit.setUV(texuv.x, texuv.y );

	  //Toujours avant normal
	  hit.setTangentSpace( ((1.0f-u-v)*this->ts[0][0]+ (u)*this->ts[1][0]+(v)*this->ts[2][0]).unit(), ((1.0f-u-v)*this->ts[0][1]+ (u)*this->ts[1][1]+(v)*this->ts[2][1]).unit() );

	  hit.setNormal( ((1.0f-u-v)*this->n[0]+ (u)*this->n[1]+(v)*this->n[2]).unit() );

	  
	  //hit.setNormal( ((1.0f-u-v)*this->v[0]+ (u)*this->v[1]+(v)*this->v[2]) );

	  //hit.setNormal(this->v[2]);


	  res=true;
  }else
	res=false;

  return res;
}


//BoxNode//
BoxNode::~BoxNode(){
	
	if(subNodes[0]){
	for(int i=0; i<triList.size(); i++)
		if(triList[i])
			delete triList[i];
	}

	if(subNodes[0])
		delete 	subNodes[0];

	if(subNodes[1])
		delete 	subNodes[1];

}

void BoxNode::buildSubNodes(int cutAxe){
	if(triList.size()>30){
		//std::cout<<"buildTree: "<<this->bbox[0].x<<"-"<<this->bbox[1].x<<" ca="<<cutAxe<<"\n";
#if 1
		subNodes[0]=new BoxNode();
		subNodes[0]->bbox[0]=this->bbox[0];
		subNodes[0]->bbox[1]=this->bbox[1];
		subNodes[0]->bbox[1].v_[cutAxe]=subNodes[0]->bbox[1].v_[cutAxe]-(subNodes[0]->bbox[1].v_[cutAxe]-subNodes[0]->bbox[0].v_[cutAxe])/2.0f;

		subNodes[1]=new BoxNode();
		subNodes[1]->bbox[0]=this->bbox[0];
		subNodes[1]->bbox[1]=this->bbox[1];
		subNodes[1]->bbox[0].v_[cutAxe]=subNodes[1]->bbox[0].v_[cutAxe]+(subNodes[1]->bbox[1].v_[cutAxe]-subNodes[1]->bbox[0].v_[cutAxe])/2.0f;


		for(int i=0; i<triList.size(); i++){
			if(triList[i]->bbox[0].v_[cutAxe] < subNodes[0]->bbox[1].v_[cutAxe])
				subNodes[0]->triList.push_back(triList[i]);

			if(triList[i]->bbox[1].v_[cutAxe] > subNodes[0]->bbox[1].v_[cutAxe])
				subNodes[1]->triList.push_back(triList[i]);
		}

		this->triList.clear();

		subNodes[0]->buildSubNodes( (cutAxe+1)%3 );
		subNodes[1]->buildSubNodes( (cutAxe+1)%3 );
#else
		subNodes[0]=new BoxNode();
		subNodes[0]->bbox[0]=this->bbox[0];
		subNodes[0]->bbox[1]=this->bbox[1];
		subNodes[0]->bbox[1].v_[cutAxe]=subNodes[0]->bbox[1].v_[cutAxe]-(subNodes[0]->bbox[1].v_[cutAxe]-subNodes[0]->bbox[0].v_[cutAxe])/2.0f;

		subNodes[1]=new BoxNode();
		subNodes[1]->bbox[0]=this->bbox[0];
		subNodes[1]->bbox[1]=this->bbox[1];
		subNodes[1]->bbox[0].v_[cutAxe]=subNodes[1]->bbox[0].v_[cutAxe]+(subNodes[1]->bbox[1].v_[cutAxe]-subNodes[1]->bbox[0].v_[cutAxe])/2.0f;


		for(int i=0; i<triList.size(); i++){
			if(triList[i]->bbox[0].v_[cutAxe] < subNodes[0]->bbox[1].v_[cutAxe])
				subNodes[0]->triList.push_back(triList[i]);

			if(triList[i]->bbox[1].v_[cutAxe] > subNodes[0]->bbox[1].v_[cutAxe])
				subNodes[1]->triList.push_back(triList[i]);
		}

		this->triList.clear();

		subNodes[0]->buildSubNodes( (cutAxe+1)%3 );
		subNodes[1]->buildSubNodes( (cutAxe+1)%3 );

#endif
	}
}

bool BoxNode::treeIntersect(const Ray& r, Hit& hit) const{
	bool res;
	res=false;

	if(this->boxIntersect(r, hit)){

		//std::cout<<"treeInter: "<<this->bbox[0].x<<"-"<<this->bbox[1].x<<"\n";
		///Leaf node
		if(!subNodes[0]){
			for(int i=0; i<this->triList.size(); i++){
				if(triList[i]->triangleIntersect(r, hit))
					res=true;
			}
		}else{
			for(int i=0; i<2; i++){
				//if(subNodes[i]->boxIntersect(r, hit)){ //bbox inter
					if(subNodes[i]->treeIntersect(r, hit))
						res=true;
				//}
			}
		}
	}

	return res;
}


void BoxNode::compBBox(){
		bbox[0]=qglviewer::Vec(999.0f,999.0f,999.0f);
		bbox[1]=qglviewer::Vec(-999.0f,-999.0f,-999.0f);

		for(int t=0; t<this->triList.size(); t++){
			for(int i=0; i<3; i++){
			  for(int j=0; j<3; j++){
				if(this->triList[t]->v[i].v_[j]<this->bbox[0].v_[j])
					this->bbox[0].v_[j]=this->triList[t]->v[i].v_[j];

				if(this->triList[t]->v[i].v_[j]>this->bbox[1].v_[j])
					this->bbox[1].v_[j]=this->triList[t]->v[i].v_[j];
			  }
			}
		}
}

void BoxNode::draw(int l){
	if(l==0){
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		//glEnable(GL_BLEND);
		//glDepthMask(false);
		glPolygonMode(GL_FRONT_AND_BACK , GL_LINE );
	
		//glPolygonMode(GL_FRONT_AND_BACK , GL_FILL );
		 
	}

	glColor4f((l*20)/255.0f, 1.0f-((l*20)/255.0f) , 0, 0.1);

	drawCube(this->bbox[0], this->bbox[1]);
	if(subNodes[0])
		this->subNodes[0]->draw(l+1);

	if(subNodes[1])
		this->subNodes[1]->draw(l+1);

	if(l==0){
		glPopAttrib();
	}
}

};